"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Hotkey = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _symbols = require("../symbols");
var innerHotkeySymbol = Symbol('innerHotkey');
var Hotkey = exports.Hotkey = /*#__PURE__*/function () {
  function Hotkey(hotkey, workspaceMode) {
    if (workspaceMode === void 0) {
      workspaceMode = false;
    }
    this.workspaceMode = workspaceMode;
    this[innerHotkeySymbol] = void 0;
    this[innerHotkeySymbol] = hotkey;
  }
  var _proto = Hotkey.prototype;
  /**
   * 绑定快捷键
   * @param combos 快捷键，格式如：['command + s'] 、['ctrl + shift + s'] 等
   * @param callback 回调函数
   * @param action
   * @returns
   */
  _proto.bind = function bind(combos, callback, action) {
    var _this = this;
    this[_symbols.hotkeySymbol].bind(combos, callback, action);
    return function () {
      _this[_symbols.hotkeySymbol].unbind(combos, callback, action);
    };
  };
  (0, _createClass2["default"])(Hotkey, [{
    key: _symbols.hotkeySymbol,
    get: function get() {
      if (this.workspaceMode) {
        return this[innerHotkeySymbol];
      }
      var workspace = _lowcodeEditorCore.globalContext.get('workspace');
      if (workspace.isActive) {
        return workspace.window.innerHotkey;
      }
      return this[innerHotkeySymbol];
    }
  }, {
    key: "callbacks",
    get: function get() {
      return this[_symbols.hotkeySymbol].callBacks;
    }

    /**
     * @deprecated
     */
  }, {
    key: "callBacks",
    get: function get() {
      return this.callbacks;
    }
  }]);
  return Hotkey;
}();