"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SimulatorHost = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _symbols = require("../symbols");
var _simulatorRender = require("../model/simulator-render");
var SimulatorHost = exports.SimulatorHost = /*#__PURE__*/function () {
  function SimulatorHost(simulator) {
    this[_symbols.simulatorHostSymbol] = void 0;
    this[_symbols.simulatorHostSymbol] = simulator;
  }
  SimulatorHost.create = function create(host) {
    if (!host) return null;
    return new SimulatorHost(host);
  }

  /**
   * 获取 contentWindow
   */;
  var _proto = SimulatorHost.prototype;
  /**
   * 设置 host 配置值
   * @param key
   * @param value
   */
  _proto.set = function set(key, value) {
    this[_symbols.simulatorHostSymbol].set(key, value);
  }

  /**
   * 获取 host 配置值
   * @param key
   * @returns
   */;
  _proto.get = function get(key) {
    return this[_symbols.simulatorHostSymbol].get(key);
  }

  /**
   * scroll to specific node
   * @param node
   */;
  _proto.scrollToNode = function scrollToNode(node) {
    this[_symbols.simulatorHostSymbol].scrollToNode(node[_symbols.nodeSymbol]);
  }

  /**
   * 触发组件构建，并刷新渲染画布
   */;
  _proto.rerender = function rerender() {
    this[_symbols.simulatorHostSymbol].rerender();
  };
  (0, _createClass2["default"])(SimulatorHost, [{
    key: "contentWindow",
    get: function get() {
      return this[_symbols.simulatorHostSymbol].contentWindow;
    }

    /**
     * 获取 contentDocument
     */
  }, {
    key: "contentDocument",
    get: function get() {
      return this[_symbols.simulatorHostSymbol].contentDocument;
    }
  }, {
    key: "renderer",
    get: function get() {
      if (this[_symbols.simulatorHostSymbol].renderer) {
        return _simulatorRender.SimulatorRender.create(this[_symbols.simulatorHostSymbol].renderer);
      }
      return undefined;
    }
  }]);
  return SimulatorHost;
}();